git-sh-setup.shon commit Merge branch 'jk/cat-file-regression-fix' (604ada4)
   1# This shell scriplet is meant to be included by other shell scripts
   2# to set up some variables pointing at the normal git directories and
   3# a few helper shell functions.
   4
   5# Having this variable in your environment would break scripts because
   6# you would cause "cd" to be taken to unexpected places.  If you
   7# like CDPATH, define it for your interactive shell sessions without
   8# exporting it.
   9# But we protect ourselves from such a user mistake nevertheless.
  10unset CDPATH
  11
  12# Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
  13# do not equate an unset IFS with IFS with the default, so here is
  14# an explicit SP HT LF.
  15IFS='   
  16'
  17
  18git_broken_path_fix () {
  19        case ":$PATH:" in
  20        *:$1:*) : ok ;;
  21        *)
  22                PATH=$(
  23                        SANE_TOOL_PATH="$1"
  24                        IFS=: path= sep=
  25                        set x $PATH
  26                        shift
  27                        for elem
  28                        do
  29                                case "$SANE_TOOL_PATH:$elem" in
  30                                (?*:/bin | ?*:/usr/bin)
  31                                        path="$path$sep$SANE_TOOL_PATH"
  32                                        sep=:
  33                                        SANE_TOOL_PATH=
  34                                esac
  35                                path="$path$sep$elem"
  36                                sep=:
  37                        done
  38                        echo "$path"
  39                )
  40                ;;
  41        esac
  42}
  43
  44# @@BROKEN_PATH_FIX@@
  45
  46die () {
  47        die_with_status 1 "$@"
  48}
  49
  50die_with_status () {
  51        status=$1
  52        shift
  53        printf >&2 '%s\n' "$*"
  54        exit "$status"
  55}
  56
  57GIT_QUIET=
  58
  59say () {
  60        if test -z "$GIT_QUIET"
  61        then
  62                printf '%s\n' "$*"
  63        fi
  64}
  65
  66if test -n "$OPTIONS_SPEC"; then
  67        usage() {
  68                "$0" -h
  69                exit 1
  70        }
  71
  72        parseopt_extra=
  73        [ -n "$OPTIONS_KEEPDASHDASH" ] &&
  74                parseopt_extra="--keep-dashdash"
  75
  76        eval "$(
  77                echo "$OPTIONS_SPEC" |
  78                        git rev-parse --parseopt $parseopt_extra -- "$@" ||
  79                echo exit $?
  80        )"
  81else
  82        dashless=$(basename "$0" | sed -e 's/-/ /')
  83        usage() {
  84                die "usage: $dashless $USAGE"
  85        }
  86
  87        if [ -z "$LONG_USAGE" ]
  88        then
  89                LONG_USAGE="usage: $dashless $USAGE"
  90        else
  91                LONG_USAGE="usage: $dashless $USAGE
  92
  93$LONG_USAGE"
  94        fi
  95
  96        case "$1" in
  97                -h)
  98                echo "$LONG_USAGE"
  99                exit
 100        esac
 101fi
 102
 103# Set the name of the end-user facing command in the reflog when the
 104# script may update refs.  When GIT_REFLOG_ACTION is already set, this
 105# will not overwrite it, so that a scripted Porcelain (e.g. "git
 106# rebase") can set it to its own name (e.g. "rebase") and then call
 107# another scripted Porcelain (e.g. "git am") and a call to this
 108# function in the latter will keep the name of the end-user facing
 109# program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it
 110# does will be record as actions done as part of the end-user facing
 111# operation (e.g. "rebase").
 112#
 113# NOTE NOTE NOTE: consequently, after assigning a specific message to
 114# GIT_REFLOG_ACTION when calling a "git" command to record a custom
 115# reflog message, do not leave that custom value in GIT_REFLOG_ACTION,
 116# after you are done.  Other callers of "git" commands that rely on
 117# writing the default "program name" in reflog expect the variable to
 118# contain the value set by this function.
 119#
 120# To use a custom reflog message, do either one of these three:
 121#
 122# (a) use a single-shot export form:
 123#     GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \
 124#         git command-that-updates-a-ref
 125#
 126# (b) save the original away and restore:
 127#     SAVED_ACTION=$GIT_REFLOG_ACTION
 128#     GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
 129#     git command-that-updates-a-ref
 130#     GIT_REFLOG_ACITON=$SAVED_ACTION
 131#
 132# (c) assign the variable in a subshell:
 133#     (
 134#         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
 135#         git command-that-updates-a-ref
 136#     )
 137set_reflog_action() {
 138        if [ -z "${GIT_REFLOG_ACTION:+set}" ]
 139        then
 140                GIT_REFLOG_ACTION="$*"
 141                export GIT_REFLOG_ACTION
 142        fi
 143}
 144
 145git_editor() {
 146        if test -z "${GIT_EDITOR:+set}"
 147        then
 148                GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
 149        fi
 150
 151        eval "$GIT_EDITOR" '"$@"'
 152}
 153
 154git_pager() {
 155        if test -t 1
 156        then
 157                GIT_PAGER=$(git var GIT_PAGER)
 158        else
 159                GIT_PAGER=cat
 160        fi
 161        : ${LESS=-FRSX}
 162        export LESS
 163
 164        eval "$GIT_PAGER" '"$@"'
 165}
 166
 167sane_grep () {
 168        GREP_OPTIONS= LC_ALL=C grep "$@"
 169}
 170
 171sane_egrep () {
 172        GREP_OPTIONS= LC_ALL=C egrep "$@"
 173}
 174
 175is_bare_repository () {
 176        git rev-parse --is-bare-repository
 177}
 178
 179cd_to_toplevel () {
 180        cdup=$(git rev-parse --show-toplevel) &&
 181        cd "$cdup" || {
 182                echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
 183                exit 1
 184        }
 185}
 186
 187require_work_tree_exists () {
 188        if test "z$(git rev-parse --is-bare-repository)" != zfalse
 189        then
 190                die "fatal: $0 cannot be used without a working tree."
 191        fi
 192}
 193
 194require_work_tree () {
 195        test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
 196        die "fatal: $0 cannot be used without a working tree."
 197}
 198
 199require_clean_work_tree () {
 200        git rev-parse --verify HEAD >/dev/null || exit 1
 201        git update-index -q --ignore-submodules --refresh
 202        err=0
 203
 204        if ! git diff-files --quiet --ignore-submodules
 205        then
 206                echo >&2 "Cannot $1: You have unstaged changes."
 207                err=1
 208        fi
 209
 210        if ! git diff-index --cached --quiet --ignore-submodules HEAD --
 211        then
 212                if [ $err = 0 ]
 213                then
 214                    echo >&2 "Cannot $1: Your index contains uncommitted changes."
 215                else
 216                    echo >&2 "Additionally, your index contains uncommitted changes."
 217                fi
 218                err=1
 219        fi
 220
 221        if [ $err = 1 ]
 222        then
 223                test -n "$2" && echo >&2 "$2"
 224                exit 1
 225        fi
 226}
 227
 228# Generate a sed script to parse identities from a commit.
 229#
 230# Reads the commit from stdin, which should be in raw format (e.g., from
 231# cat-file or "--pretty=raw").
 232#
 233# The first argument specifies the ident line to parse (e.g., "author"), and
 234# the second specifies the environment variable to put it in (e.g., "AUTHOR"
 235# for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
 236# committer.
 237pick_ident_script () {
 238        while test $# -gt 0
 239        do
 240                lid=$1; shift
 241                uid=$1; shift
 242                printf '%s' "
 243                /^$lid /{
 244                        s/'/'\\\\''/g
 245                        h
 246                        s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
 247                        s/.*/GIT_${uid}_NAME='&'/p
 248
 249                        g
 250                        s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
 251                        s/.*/GIT_${uid}_EMAIL='&'/p
 252
 253                        g
 254                        s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
 255                        s/.*/GIT_${uid}_DATE='&'/p
 256                }
 257                "
 258        done
 259        echo '/^$/q'
 260}
 261
 262# Create a pick-script as above and feed it to sed. Stdout is suitable for
 263# feeding to eval.
 264parse_ident_from_commit () {
 265        LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
 266}
 267
 268# Parse the author from a commit given as an argument. Stdout is suitable for
 269# feeding to eval to set the usual GIT_* ident variables.
 270get_author_ident_from_commit () {
 271        encoding=$(git config i18n.commitencoding || echo UTF-8)
 272        git show -s --pretty=raw --encoding="$encoding" "$1" -- |
 273        parse_ident_from_commit author AUTHOR
 274}
 275
 276# Clear repo-local GIT_* environment variables. Useful when switching to
 277# another repository (e.g. when entering a submodule). See also the env
 278# list in git_connect()
 279clear_local_git_env() {
 280        unset $(git rev-parse --local-env-vars)
 281}
 282
 283# Generate a virtual base file for a two-file merge. Uses git apply to
 284# remove lines from $1 that are not in $2, leaving only common lines.
 285create_virtual_base() {
 286        sz0=$(wc -c <"$1")
 287        @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
 288        sz1=$(wc -c <"$1")
 289
 290        # If we do not have enough common material, it is not
 291        # worth trying two-file merge using common subsections.
 292        expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
 293}
 294
 295
 296# Platform specific tweaks to work around some commands
 297case $(uname -s) in
 298*MINGW*)
 299        # Windows has its own (incompatible) sort and find
 300        sort () {
 301                /usr/bin/sort "$@"
 302        }
 303        find () {
 304                /usr/bin/find "$@"
 305        }
 306        # git sees Windows-style pwd
 307        pwd () {
 308                builtin pwd -W
 309        }
 310        is_absolute_path () {
 311                case "$1" in
 312                [/\\]* | [A-Za-z]:*)
 313                        return 0 ;;
 314                esac
 315                return 1
 316        }
 317        ;;
 318*)
 319        is_absolute_path () {
 320                case "$1" in
 321                /*)
 322                        return 0 ;;
 323                esac
 324                return 1
 325        }
 326esac
 327
 328# Make sure we are in a valid repository of a vintage we understand,
 329# if we require to be in a git repository.
 330if test -z "$NONGIT_OK"
 331then
 332        GIT_DIR=$(git rev-parse --git-dir) || exit
 333        if [ -z "$SUBDIRECTORY_OK" ]
 334        then
 335                test -z "$(git rev-parse --show-cdup)" || {
 336                        exit=$?
 337                        echo >&2 "You need to run this command from the toplevel of the working tree."
 338                        exit $exit
 339                }
 340        fi
 341        test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
 342                echo >&2 "Unable to determine absolute path of git directory"
 343                exit 1
 344        }
 345        : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
 346fi
 347
 348peel_committish () {
 349        case "$1" in
 350        :/*)
 351                peeltmp=$(git rev-parse --verify "$1") &&
 352                git rev-parse --verify "${peeltmp}^0"
 353                ;;
 354        *)
 355                git rev-parse --verify "${1}^0"
 356                ;;
 357        esac
 358}